"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.services = void 0;
/** @format */
var utils_1 = require("../utils");
var sdk_1 = require("../sdk");
var constants_1 = require("../constants");
var service_1 = require("../service");
function initBaseInfo(context, baseInfos) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!!baseInfos.session) return [3 /*break*/, 2];
                    // @ts-ignore
                    _a = baseInfos;
                    return [4 /*yield*/, new service_1.TaobaoTopService(context).getAccessTokenByOpenId()];
                case 1:
                    // @ts-ignore
                    _a.session = _b.sent();
                    _b.label = 2;
                case 2: return [2 /*return*/, baseInfos];
            }
        });
    });
}
exports.services = function (services) {
    return function (target, name, descriptor) {
        var method = descriptor.value;
        descriptor.value = function () {
            var _a, _b, _c;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var context, _d, otherArgs, servicesInstance, baseInfos, ret, error_1;
                return __generator(this, function (_e) {
                    switch (_e.label) {
                        case 0:
                            context = args[0], _d = args[1], otherArgs = _d === void 0 ? {} : _d;
                            servicesInstance = services.map(function (v) { return new v(context); });
                            return [4 /*yield*/, initBaseInfo(context, otherArgs)
                                // 默认全局try catch  如果有noCatch参数则直接执行
                            ];
                        case 1:
                            baseInfos = _e.sent();
                            // 默认全局try catch  如果有noCatch参数则直接执行
                            if (baseInfos.noCatch) {
                                delete baseInfos.noCatch;
                                return [2 /*return*/, method.apply(target, [context, baseInfos, servicesInstance])];
                            }
                            _e.label = 2;
                        case 2:
                            _e.trys.push([2, 4, , 6]);
                            utils_1.logger(context);
                            return [4 /*yield*/, method.apply(target, [context, baseInfos, servicesInstance])];
                        case 3:
                            ret = _e.sent();
                            return [3 /*break*/, 6];
                        case 4:
                            error_1 = _e.sent();
                            console.log('error', error_1);
                            return [4 /*yield*/, utils_1.recordErrorLog(context, baseInfos, error_1.toString(), error_1.stack)];
                        case 5:
                            _e.sent();
                            ret = sdk_1.resultsModel.error(constants_1.CODE_TYPES.SYSTEM_ERROR, (((_c = (_b = (_a = context === null || context === void 0 ? void 0 : context.cloud) === null || _a === void 0 ? void 0 : _a.dataspace) === null || _b === void 0 ? void 0 : _b.context) === null || _c === void 0 ? void 0 : _c.handler) || context.handler) + "\u7CFB\u7EDF\u9519\u8BEF");
                            return [3 /*break*/, 6];
                        case 6: return [2 /*return*/, ret];
                    }
                });
            });
        };
    };
};
//# sourceMappingURL=services.js.map