/** @format */

import ActivityController from './controller/activity.controller'
import SellerController from './controller/seller.controller'
import AwardsController from './controller/awards.controller'
import RuleController from './controller/rule.controller'
import RaobaoItemController from './controller/taobaoItem.controller'
import SaveController from './controller/save.controller'

const { getActivityList, getActivityDetail, delActivity } = new ActivityController()
const { sellerSaasSave, sellerSave } = new SellerController()
const {
  findWinnerInfoList,
  exportAwardsList,
  findWinnerInfoListBySearch,
  downloadFile,
  exportAwardsInfoBySearch
} = new AwardsController()
const { generateRule } = new RuleController()
const { findItemListByStatus, findItemListByIds, queryBenefitByEname } = new RaobaoItemController()
const { saveActivityInfo } = new SaveController()

export default {
  getActivityList,
  getActivityDetail,
  delActivity,
  saveActivityInfo,
  sellerSave,
  findWinnerInfoList,
  exportAwardsList,
  findWinnerInfoListBySearch,
  downloadFile,
  exportAwardsInfoBySearch,
  findItemListByStatus,
  findItemListByIds,
  queryBenefitByEname
}
